package main

import (
	"git.sp4ke.com/sp4ke/bit4sat/storage"
	"github.com/gin-contrib/cors"
	"github.com/gin-gonic/gin"
)

var (
	UploadCtrl = storage.UploadCtrl{}
)

type API struct {
	router *gin.Engine
}

func (api *API) Run() {

	uploadRoute := api.router.Group("/upload")
	{

		uploadRoute.POST("/", UploadCtrl.New)
		uploadRoute.PUT("/:id", UploadCtrl.Upload)

	}

	api.router.Run(":8880")
}

func NewAPI() *API {
	router := gin.Default()
	router.Use(cors.Default())

	return &API{
		router: router,
	}
}
